 % 3-D plotter for kite trajectories
 % This is NOOOT the same co-ordinate system used in the skysails paper
 % HERE:  x axis makes angle chi with the wind (roughly aligned)
 %        z axis is vertical
 %        y axis is to your left when facing downwind standing upright
 % Thus the signs of y and z are permuted with respect to the skysails
 % paper
 function myplothandle = my3Dplotter(theta,phi,mycolor)
    
global P;

if(iscolumn(theta))
    w = theta';
    p = phi';
else
    w = theta;
    p = phi;
end
  
 %get the points in cartesian
 kitepos = P.r*[cos(w);...
            +sin(p).*sin(w);...
            +cos(p).*sin(w)];
 
 %       
 myplothandle = plot3(kitepos(1,:), kitepos(2,:), kitepos(3,:),mycolor, 'LineWidth',3);
 axis equal
 axis(P.r*[0, 1, -1, 1, 0, 1])
 xlabel('x'), ylabel('y'), zlabel('z'),
 grid on
 hold on
 %plot intial point
 plot3(kitepos(1,1), kitepos(2,1), kitepos(3,1),'ro')
 
 % plot a quarter sphere (transparent)
 [unit_x,unit_y,unit_z] = sphere;
 x = P.r*unit_x; y = P.r*unit_y; z = P.r*unit_z; %multiply by the radius
 i1=(x>=0)&(z>=0);
  i3=~i1;
 x(i3)=nan;y(i3)=nan;z(i3)=nan;
 mesh(x,y,z, 'EdgeColor','black','facecolor','none')
 axis equal
 alpha(.3)
 
 %plot the height constraint
r = P.r*sqrt(1 - (P.z_min/P.r)^2); %distance from z axis to constraint projected onto the x-y plane
a =  -pi/2:pi/90:pi/2; 
dummy = ones(1,length(a));
z = (P.z_min)*dummy;
x = r*cos(a);
y = r*sin(a);
plot3(x,y,z,'c','LineWidth',2)
set(gcf,'Color','white') 

view(-90,10);

















     
 
 